Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs	(revision 9088)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs	(revision 9089)
@@ -20,9 +20,8 @@
 #endregion
 
-using HeuristicLab.Algorithms.GeneticAlgorithm;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.CombinedIntegerVectorEncoding;
+using HeuristicLab.Encodings.ConditionActionEncoding;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Operators;
@@ -31,5 +30,4 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Random;
 using HeuristicLab.Selection;
 
@@ -40,5 +38,5 @@
   [Item("LearningClassifierSystemMainLoop", "An operator which represents the main loop of a learning classifier system.")]
   [StorableClass]
-  public class LearningClassifierSystemMainLoop : AlgorithmOperator {
+  public sealed class LearningClassifierSystemMainLoop : AlgorithmOperator {
 
     #region Parameter Properties
@@ -54,22 +52,19 @@
     #endregion
 
-    #region Properties
-    public ISelector Selector {
-      get { return SelectorParameter.Value; }
-      set { SelectorParameter.Value = value; }
-    }
-    public ICrossover Crossover {
-      get { return CrossoverParameter.Value; }
-      set { CrossoverParameter.Value = value; }
-    }
-    public IManipulator Mutator {
-      get { return MutatorParameter.Value; }
-      set { MutatorParameter.Value = value; }
-    }
+    #region private properties
+    private SolutionsCreator initialSolutionsCreator;
+    private SolutionsCreator coveringMechanism;
+    private MatchConditionOperator matchConditionOperator;
+    private PredictionArrayCalculator predictionArrayCalculator;
+    private ActionSelector actionSelector;
+
+    private Placeholder evaluator;
+    private Placeholder actionExecuter;
+    private Placeholder classifierFetcher;
     #endregion
 
     [StorableConstructor]
     private LearningClassifierSystemMainLoop(bool deserializing) : base(deserializing) { }
-    protected LearningClassifierSystemMainLoop(LearningClassifierSystemMainLoop original, Cloner cloner)
+    private LearningClassifierSystemMainLoop(LearningClassifierSystemMainLoop original, Cloner cloner)
       : base(original, cloner) {
     }
@@ -85,107 +80,162 @@
       #region Create parameters
       Parameters.Add(new ConstrainedValueParameter<ISelector>("Selector", "The operator used to select solutions for reproduction.", new ItemSet<ISelector>() { new ProportionalSelector() }, new ProportionalSelector()));
-      Parameters.Add(new ConstrainedValueParameter<ICrossover>("Crossover", "The operator used to cross solutions.", new ItemSet<ICrossover>() { new SinglePointCrossover() }, new SinglePointCrossover()));
-      Parameters.Add(new OptionalConstrainedValueParameter<IManipulator>("Mutator", "The operator used to mutate solutions.", new ItemSet<IManipulator>() { new UniformOnePositionManipulator() }, new UniformOnePositionManipulator()));
-      //for test purposes
-      int[] numbers = new int[3] { 1, 1, 1 };
-      int[,] elements = new int[,] { { 0, 3 }, { 0, 3 }, { 0, 2 } };
-      Parameters.Add(new ValueLookupParameter<CombinedIntegerVector>("TestTarget", "Target for test", new CombinedIntegerVector(numbers, 1, elements)));
-
+      Parameters.Add(new ConstrainedValueParameter<ICrossover>("Crossover", "The operator used to cross solutions.", new ItemSet<ICrossover>() { new HeuristicLab.Encodings.CombinedIntegerVectorEncoding.SinglePointCrossover() }, new HeuristicLab.Encodings.CombinedIntegerVectorEncoding.SinglePointCrossover()));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator", "The operator used to evaluate solutions. This operator is executed in parallel, if an engine is used which supports parallelization."));
+      UniformOnePositionManipulator test = new UniformOnePositionManipulator();
+      test.IntegerVectorParameter.ActualName = "CombinedIntegerVector";
+      Parameters.Add(new OptionalConstrainedValueParameter<IManipulator>("Mutator", "The operator used to mutate solutions.", new ItemSet<IManipulator>() { new UniformOnePositionManipulator() }, test));
       #endregion
 
       #region Create operators
       VariableCreator variableCreator = new VariableCreator();
-      MatchSelector conditionMatchSelector = new MatchSelector();
-      MatchSelector actionMatchSelector = new MatchSelector();
+      ConditionalBranch initialPopulationConditionalBranch = new ConditionalBranch();
+      initialSolutionsCreator = new SolutionsCreator();
+      IntCounter iterationCounter = new IntCounter();
+      UniformSubScopesProcessor matchCondtionSubScopesProcessor = new UniformSubScopesProcessor();
+      matchConditionOperator = new MatchConditionOperator();
+      predictionArrayCalculator = new PredictionArrayCalculator();
+      actionSelector = new ActionSelector();
+      UniformSubScopesProcessor matchActionSubScopesProcessor = new UniformSubScopesProcessor();
+      MatchActionOperator matchActionOperator = new MatchActionOperator();
+      ConditionalSelector conditionMatchSelector = new ConditionalSelector();
+      ConditionalSelector actionMatchSelector = new ConditionalSelector();
       SubScopesProcessor coveringSubScopesProcessor = new SubScopesProcessor();
-      SubScopesRemover subScopesRemover = new SubScopesRemover();
+      SubScopesCounter matchsetCounter = new SubScopesCounter();
       Comparator comparator = new Comparator();
-      ConditionalBranch conditionalBranch = new ConditionalBranch();
+      ConditionalBranch coveringConditionalBranch = new ConditionalBranch();
       MergingReducer mergingReducer = new MergingReducer();
-      SolutionsCreator coveringMechanism = new SolutionsCreator();
-      SubScopesProcessor actionSelectionSubScopesProcessor = new SubScopesProcessor();
-      MaxValueActionSelector maxValueActionSelection = new MaxValueActionSelector();
-      GeneticAlgorithmMainLoop geneticAlgorithmMainLoop = new GeneticAlgorithmMainLoop();
-
-      UniformSubScopesProcessor uniformSubScopeProcessor = new UniformSubScopesProcessor();
-      UniformRandomizer uniformRandomizer = new UniformRandomizer();
+      MergingReducer mergingReducerWithSuccessor = new MergingReducer();
+      coveringMechanism = new SolutionsCreator();
+      evaluator = new Placeholder();
+      SubScopesProcessor actionSetSubScopesProcessor = new SubScopesProcessor();
+      DataReducer actionSetSizeDataReducer = new DataReducer();
+      UniformSubScopesProcessor accuracySubScopesProcessor = new UniformSubScopesProcessor();
+      CalculateAccuracy calculateAccuracy = new CalculateAccuracy();
+      SumAccuracy sumAccuracy = new SumAccuracy();
+      UniformSubScopesProcessor updateParametersSubScopesProcessor = new UniformSubScopesProcessor();
+      LCSAdaptedGeneticAlgorithm adaptedGeneticAlgorithmMainLoop = new LCSAdaptedGeneticAlgorithm();
+
+      classifierFetcher = new Placeholder();
+      actionExecuter = new Placeholder();
 
       variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("ZeroIntValue", new IntValue(0)));
       variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("OneIntValue", new IntValue(1)));
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Iteration", new IntValue(0)));
+
+      initialPopulationConditionalBranch.ConditionParameter.ActualName = "CreateInitialPopulation";
+
+      initialSolutionsCreator.NumberOfSolutionsParameter.ActualName = "N";
+
+      iterationCounter.ValueParameter.ActualName = "Iteration";
+      iterationCounter.IncrementParameter.ActualName = "OneIntValue";
+
+      matchCondtionSubScopesProcessor.Operator = matchConditionOperator;
+
+      matchConditionOperator.MatchParameter.ActualName = "CombinedIntegerVector";
 
       conditionMatchSelector.CopySelected = new BoolValue(false);
-      conditionMatchSelector.MatchCondition = new BoolValue(true);
-      //this has to be set differently
-      conditionMatchSelector.MatchParameter.ActualName = "CombinedIntegerVector";
-      conditionMatchSelector.TargetMatchParameter.ActualName = "TestTarget";
+      conditionMatchSelector.ConditionParameter.ActualName = "MatchCondition";
+
+      matchsetCounter.Name = "Count number of rules in match set";
+      matchsetCounter.AccumulateParameter.Value = new BoolValue(false);
+      matchsetCounter.ValueParameter.ActualName = "MatchSetCount";
 
       comparator.Comparison = new Comparison(ComparisonType.LessOrEqual);
-      comparator.LeftSideParameter.ActualName = conditionMatchSelector.NumberOfSelectedSubScopesParameter.ActualName;
+      comparator.LeftSideParameter.ActualName = matchsetCounter.ValueParameter.ActualName;
       comparator.ResultParameter.ActualName = "Covering";
       //more than zero solutions have to be selected
       comparator.RightSideParameter.ActualName = "ZeroIntValue";
 
-      conditionalBranch.ConditionParameter.ActualName = "Covering";
-
-      subScopesRemover.SubScopeIndexParameter.ActualName = "OneIntValue";
-      subScopesRemover.RemoveAllSubScopes = false;
+      coveringConditionalBranch.Name = "Covering Branch";
+      coveringConditionalBranch.ConditionParameter.ActualName = "Covering";
+
+      matchActionSubScopesProcessor.Operator = matchActionOperator;
+
+      matchActionOperator.MatchParameter.ActualName = "CombinedIntegerVector";
+      matchActionOperator.TargetMatchParameter.ActualName = actionSelector.SelectedActionParameter.ActualName;
 
       coveringMechanism.NumberOfSolutionsParameter.ActualName = "OneIntValue";
-      coveringMechanism.SolutionCreatorParameter.ActualName = "SolutionCreator";
-
-      maxValueActionSelection.ValueParameter.ActualName = "Fitness";
-      maxValueActionSelection.MatchParameter.ActualName = "CombinedIntegerVector";
+
+      predictionArrayCalculator.MatchParameter.ActualName = "CombinedIntegerVector";
+
+      actionSelector.PredictionArrayParameter.ActualName = predictionArrayCalculator.PredictionArrayParameter.Name;
+      actionSelector.RandomParameter.ActualName = "Random";
+      actionSelector.ExplorationProbabilityParameter.ActualName = "ExplorationProbability";
 
       actionMatchSelector.CopySelected = new BoolValue(false);
-      actionMatchSelector.MatchCondition = new BoolValue(false);
-      //this has to be set differently
-      actionMatchSelector.MatchParameter.ActualName = "CombinedIntegerVector";
-      actionMatchSelector.TargetMatchParameter.ActualName = maxValueActionSelection.SelectedActionParameter.ActualName;
+      actionMatchSelector.ConditionParameter.ActualName = "MatchAction";
 
       SelectorParameter.Value.CopySelected = new BoolValue(true);
       SelectorParameter.Value.NumberOfSelectedSubScopesParameter.Value = new IntValue(200);
 
-      geneticAlgorithmMainLoop.SelectorParameter.ActualName = SelectorParameter.Name;
-      geneticAlgorithmMainLoop.CrossoverParameter.ActualName = CrossoverParameter.Name;
-      geneticAlgorithmMainLoop.MutatorParameter.ActualName = MutatorParameter.Name;
-      geneticAlgorithmMainLoop.RandomParameter.ActualName = "Random";
-      geneticAlgorithmMainLoop.ElitesParameter.ActualName = "OneIntValue";
-      geneticAlgorithmMainLoop.MaximumGenerationsParameter.ActualName = "ZeroIntValue";
-      geneticAlgorithmMainLoop.QualityParameter.ActualName = "Fitness";
+      evaluator.Name = "Evaluator";
+
+      classifierFetcher.Name = "ClassifierFetcher";
+
+      actionExecuter.Name = "ActionExecuter";
+
+      actionSetSizeDataReducer.TargetParameter.ActualName = "CurrentActionSetSize";
+      actionSetSizeDataReducer.ParameterToReduce.ActualName = "Numerosity";
+      actionSetSizeDataReducer.ReductionOperation.Value = new ReductionOperation(ReductionOperations.Sum);
+      actionSetSizeDataReducer.TargetOperation.Value = new ReductionOperation(ReductionOperations.Assign);
+
+      calculateAccuracy.AlphaParameter.ActualName = "Alpha";
+      calculateAccuracy.ErrorParameter.ActualName = "Error";
+      calculateAccuracy.ErrorZeroParameter.ActualName = "ErrorZero";
+      calculateAccuracy.PowerParameter.ActualName = "v";
+
+      sumAccuracy.AccuracyParameter.ActualName = calculateAccuracy.AccuracyParameter.ActualName;
+      sumAccuracy.NumerosityParameter.ActualName = "Numerosity";
+
+      adaptedGeneticAlgorithmMainLoop.SelectorParameter.ActualName = SelectorParameter.Name;
+      adaptedGeneticAlgorithmMainLoop.CrossoverParameter.ActualName = CrossoverParameter.Name;
+      adaptedGeneticAlgorithmMainLoop.MutatorParameter.ActualName = MutatorParameter.Name;
+      adaptedGeneticAlgorithmMainLoop.RandomParameter.ActualName = "Random";
+      adaptedGeneticAlgorithmMainLoop.MaximumGenerationsParameter.ActualName = "ZeroIntValue";
+      adaptedGeneticAlgorithmMainLoop.QualityParameter.ActualName = "Fitness";
       //needed?
-      geneticAlgorithmMainLoop.MutationProbabilityParameter.Value = new PercentValue(10);
-      geneticAlgorithmMainLoop.MaximizationParameter.Value = new BoolValue(true);
-
-      uniformSubScopeProcessor.Parallel = new BoolValue(true);
-
-      uniformRandomizer.RandomParameter.ActualName = "Random";
-      uniformRandomizer.MinParameter.Value = new DoubleValue(0);
-      uniformRandomizer.MaxParameter.Value = new DoubleValue(100);
-      uniformRandomizer.ValueParameter.ActualName = "Fitness";
-
-      //ParameterizeSelectors();
+      adaptedGeneticAlgorithmMainLoop.MutationProbabilityParameter.Value = new PercentValue(10);
+      adaptedGeneticAlgorithmMainLoop.MaximizationParameter.Value = new BoolValue(true);
       #endregion
 
       #region Create operator graph
       OperatorGraph.InitialOperator = variableCreator;
-      variableCreator.Successor = conditionMatchSelector;
-      //variableCreator.Successor = geneticAlgorithmMainLoop;
-      //geneticAlgorithmMainLoop.Successor = conditionMatchSelector;
-      conditionMatchSelector.Successor = comparator;
-      comparator.Successor = conditionalBranch;
-      conditionalBranch.TrueBranch = coveringSubScopesProcessor;
-      conditionalBranch.FalseBranch = actionSelectionSubScopesProcessor;
-      conditionalBranch.Successor = subScopesRemover;
-      coveringMechanism.Successor = uniformSubScopeProcessor;
-      uniformSubScopeProcessor.Operator = uniformRandomizer;
+
+      variableCreator.Successor = initialPopulationConditionalBranch;
+      initialPopulationConditionalBranch.TrueBranch = initialSolutionsCreator;
+      initialPopulationConditionalBranch.FalseBranch = new EmptyOperator();
+      initialPopulationConditionalBranch.Successor = classifierFetcher;
+      classifierFetcher.Successor = matchCondtionSubScopesProcessor;
+      matchCondtionSubScopesProcessor.Successor = conditionMatchSelector;
+      //variableCreator.Successor = adaptedGeneticAlgorithmMainLoop;
+      //adaptedGeneticAlgorithmMainLoop.Successor = conditionMatchSelector;
+
+      conditionMatchSelector.Successor = coveringSubScopesProcessor;
       coveringSubScopesProcessor.Operators.Add(new EmptyOperator());
-      coveringSubScopesProcessor.Operators.Add(coveringMechanism);
-      coveringSubScopesProcessor.Successor = actionSelectionSubScopesProcessor;
-      actionSelectionSubScopesProcessor.Operators.Add(new EmptyOperator());
-      actionSelectionSubScopesProcessor.Operators.Add(maxValueActionSelection);
-      maxValueActionSelection.Successor = actionMatchSelector;
-      subScopesRemover.Successor = mergingReducer;
-      mergingReducer.Successor = conditionMatchSelector;
-      //mergingReducer.Successor = geneticAlgorithmMainLoop;
+      coveringSubScopesProcessor.Operators.Add(matchsetCounter);
+      coveringSubScopesProcessor.Successor = mergingReducerWithSuccessor;
+      matchsetCounter.Successor = comparator;
+      comparator.Successor = coveringConditionalBranch;
+      coveringConditionalBranch.TrueBranch = coveringMechanism;
+      coveringConditionalBranch.FalseBranch = new EmptyOperator();
+      coveringConditionalBranch.Successor = predictionArrayCalculator;
+      predictionArrayCalculator.Successor = actionSelector;
+      actionSelector.Successor = matchActionSubScopesProcessor;
+      matchActionSubScopesProcessor.Successor = actionMatchSelector;
+      actionMatchSelector.Successor = actionExecuter;
+      actionExecuter.Successor = actionSetSubScopesProcessor;
+      actionSetSubScopesProcessor.Operators.Add(new EmptyOperator());
+      actionSetSubScopesProcessor.Operators.Add(actionSetSizeDataReducer);
+      actionSetSizeDataReducer.Successor = accuracySubScopesProcessor;
+      accuracySubScopesProcessor.Operator = calculateAccuracy;
+      accuracySubScopesProcessor.Successor = sumAccuracy;
+      sumAccuracy.Successor = updateParametersSubScopesProcessor;
+      updateParametersSubScopesProcessor.Operator = evaluator;
+
+      actionSetSubScopesProcessor.Successor = mergingReducer;
+
+      mergingReducerWithSuccessor.Successor = iterationCounter;
+      iterationCounter.Successor = classifierFetcher;
+      //mergingReducer.Successor = adaptedGeneticAlgorithmMainLoop;
       #endregion
     }
@@ -197,4 +247,27 @@
         stochasticOp.RandomParameter.Hidden = true;
       }
+    }
+
+    internal void SetCurrentProblem(IConditionActionProblem problem) {
+      initialSolutionsCreator.SolutionCreatorParameter.ActualName = problem.SolutionCreatorParameter.Name;
+      initialSolutionsCreator.EvaluatorParameter.ActualName = problem.EvaluatorParameter.Name;
+
+      coveringMechanism.SolutionCreatorParameter.ActualName = problem.SolutionCreatorParameter.Name;
+      coveringMechanism.EvaluatorParameter.ActualName = problem.EvaluatorParameter.Name;
+
+      problem.ActionExecuter.SelectedActionParameter.ActualName = actionSelector.SelectedActionParameter.ActualName;
+
+      problem.ClassifierFetcher.IterationParameter.ActualName = "Iteration";
+
+      evaluator.OperatorParameter.ActualName = problem.EvaluatorParameter.Name;
+
+      classifierFetcher.OperatorParameter.ActualName = problem.ClassifierFetcherParameter.Name;
+
+      actionExecuter.OperatorParameter.ActualName = problem.ActionExecuterParameter.Name;
+
+      matchConditionOperator.TargetMatchParameter.ActualName = problem.ClassifierFetcher.CurrentClassifierToMatchParameter.Name;
+
+      predictionArrayCalculator.PredictionParameter.ActualName = problem.Evaluator.PredictionParameter.ActualName;
+      predictionArrayCalculator.FitnessParameter.ActualName = problem.Evaluator.FitnessParameter.ActualName;
     }
     //private void ParameterizeSelectors() {
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs	(revision 9088)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs	(revision 9089)
@@ -25,4 +25,6 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ConditionActionEncoding;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -31,8 +33,9 @@
   [StorableClass]
   [Item("CombinedIntegerVector", "Represents a combined vector of integer values.")]
-  public class CombinedIntegerVector : IntegerVector, IMatching {
+  public class CombinedIntegerVector : IntegerVector, IClassifier {
 
     [Storable]
-    protected int actionPart;
+    protected int actionLength;
+    public int ActionLength { get { return actionLength; } }
 
     /// <summary>
@@ -42,5 +45,6 @@
     /// </summary>
     [Storable]
-    protected int[,] bounds;
+    protected IntMatrix bounds;
+    public IntMatrix Bounds { get { return (IntMatrix)bounds.Clone(); } }
 
     [StorableConstructor]
@@ -48,24 +52,45 @@
     public CombinedIntegerVector() : base() { }
 
-    public CombinedIntegerVector(int[] elements, int actionPart, int[,] bounds)
+    public CombinedIntegerVector(int[] elements, int actionPart, IntMatrix bounds)
       : base(elements) {
-      this.actionPart = actionPart;
+      this.actionLength = actionPart;
       //check if combinedVector satisfies bounds and if bounds is set correctly (at leats one row with 2 columns) is missing!
       this.bounds = bounds;
     }
 
-    public CombinedIntegerVector(IntegerVector combinedVector, int actionPart, int[,] bounds)
+    public CombinedIntegerVector(IntegerVector combinedVector, int actionPart, IntMatrix bounds)
       : this(combinedVector.ToArray(), actionPart, bounds) { }
 
-    public CombinedIntegerVector(IntegerVector condition, IntegerVector action, int[,] bounds)
+    public CombinedIntegerVector(IntegerVector condition, IntegerVector action, IntMatrix bounds)
       : base(condition.Concat(action).ToArray()) {
-      actionPart = action.Length;
+      actionLength = action.Length;
       //check if combinedVector satisfies bounds and if bounds is set correctly (at leats one row with 2 columns) is missing!
       this.bounds = bounds;
     }
 
+    public CombinedIntegerVector(IntegerVector condition, IntMatrix conditionBounds, IntegerVector action, IntMatrix actionBounds)
+      : this(condition, action, CombineBounds(conditionBounds, actionBounds)) {
+    }
+
+    private static IntMatrix CombineBounds(IntMatrix conditionBounds, IntMatrix actionBounds) {
+      int columns = conditionBounds.Columns < actionBounds.Columns ? conditionBounds.Columns : actionBounds.Columns;
+      IntMatrix bounds = new IntMatrix(conditionBounds.Rows + actionBounds.Rows, columns);
+      for (int i = 0; i < conditionBounds.Rows; i++) {
+        for (int j = 0; j < columns; j++) {
+          bounds[i, j] = conditionBounds[i % conditionBounds.Rows, j];
+        }
+      }
+
+      for (int i = conditionBounds.Rows; i < actionBounds.Rows + conditionBounds.Rows; i++) {
+        for (int j = 0; j < columns; j++) {
+          bounds[i, j] = actionBounds[i % actionBounds.Rows, j];
+        }
+      }
+      return bounds;
+    }
+
     public CombinedIntegerVector(IRandom random, int length, int min, int max, int actionLenght, int actionMin, int actionMax) :
       this(new IntegerVector(length, random, min, max), new IntegerVector(actionLenght, random, actionMin, actionMax), null) {
-      bounds = new int[length + actionLenght, 2];
+      bounds = new IntMatrix(length + actionLenght, 2);
       for (int i = 0; i < length; i++) {
         bounds[i, 0] = min;
@@ -78,7 +103,7 @@
     }
 
-    public CombinedIntegerVector(int length, int actionPart, int[,] bounds)
+    public CombinedIntegerVector(int length, int actionPart, IntMatrix bounds)
       : base(length) {
-      this.actionPart = actionPart;
+      this.actionLength = actionPart;
       this.bounds = bounds;
     }
@@ -86,28 +111,43 @@
     protected CombinedIntegerVector(CombinedIntegerVector original, Cloner cloner)
       : base(original, cloner) {
-      actionPart = original.actionPart;
-      bounds = (int[,])original.bounds.Clone();
-    }
+      actionLength = original.actionLength;
+      bounds = (IntMatrix)original.bounds.Clone();
+    }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new CombinedIntegerVector(this, cloner);
     }
 
-    public IMatching Condition {
+    public IClassifier Condition {
       get {
-        int[] condition = new int[Length - actionPart];
-        Array.Copy(this.array, condition, Length - actionPart);
+        int[] condition = new int[Length - actionLength];
+        Array.Copy(this.array, condition, Length - actionLength);
         return new CombinedIntegerVector(condition, 0, bounds);
       }
     }
 
-    public IMatching Action {
+    public IClassifier Action {
       get {
-        int[] action = new int[actionPart];
-        Array.Copy(this.array, Length - actionPart, action, 0, actionPart);
-        return new CombinedIntegerVector(action, actionPart, bounds);
-      }
-    }
-
-    public bool MatchCondition(IMatching target) {
+        int[] action = new int[actionLength];
+        Array.Copy(this.array, Length - actionLength, action, 0, actionLength);
+
+        IntMatrix actionBounds = GetElementsOfBoundsForAction(bounds, Length, actionLength);
+        return new CombinedIntegerVector(action, actionLength, actionBounds);
+      }
+    }
+
+    private IntMatrix GetElementsOfBoundsForAction(IntMatrix bounds, int length, int actionPartLength) {
+      IntMatrix actionBounds = new IntMatrix(actionPartLength, bounds.Columns);
+      int start = length - actionPartLength;
+      for (int i = start; i < length; i++) {
+        int pos = i % bounds.Rows;
+        for (int j = 0; j < bounds.Columns; j++) {
+          actionBounds[i - start, j] = bounds[pos, j];
+        }
+      }
+      return actionBounds;
+    }
+
+    public bool MatchCondition(IClassifier target) {
       var targetVector = target as CombinedIntegerVector;
       if (targetVector == null) return false;
@@ -115,6 +155,6 @@
 
       int curbounds;
-      for (int i = 0; i < this.Length - this.actionPart; i++) {
-        curbounds = i % bounds.GetLength(0);
+      for (int i = 0; i < this.Length - this.actionLength; i++) {
+        curbounds = i % bounds.Rows;
         //if don't care symbol is matched, next indices can be checked
         if (this[i].Equals(bounds[curbounds, 1] - 1)) {
@@ -129,12 +169,12 @@
 
     // no "don't care" symbols have to be considered
-    public bool MatchAction(IMatching target) {
+    public bool MatchAction(IClassifier target) {
       var targetVector = target as CombinedIntegerVector;
       if (targetVector == null) return false;
-      if (targetVector.actionPart != this.actionPart) return false;
-
-      int curPos = this.Length - this.actionPart;
-      int curTargetPos = targetVector.Length - targetVector.actionPart;
-      for (int i = 0; i < this.actionPart; i++) {
+      if (targetVector.actionLength != this.actionLength) return false;
+
+      int curPos = this.Length - this.actionLength;
+      int curTargetPos = targetVector.Length - targetVector.actionLength;
+      for (int i = 0; i < this.actionLength; i++) {
         if (!this[curPos + i].Equals(targetVector[curTargetPos + i])) {
           return false;
@@ -149,6 +189,6 @@
       int curbounds;
       for (int i = 0; i < this.Length; i++) {
-        curbounds = i % bounds.GetLength(0);
-        if (i >= this.Length - this.actionPart || this[i] < bounds[curbounds, 1] - 1) {
+        curbounds = i % bounds.Rows;
+        if (i >= this.Length - this.actionLength || this[i] < bounds[curbounds, 1] - 1) {
           strBuilder.Append(this[i]);
         } else {
@@ -171,10 +211,10 @@
     }
 
-    public bool Equals(IMatching other) {
+    public bool Equals(IClassifier other) {
       return this.MatchAction(other) && this.MatchCondition(other);
     }
 
     public override int GetHashCode() {
-      int result = actionPart;
+      int result = actionLength;
       for (int i = 0; i < array.Length; i++) {
         result ^= array[i];
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorCreator.cs	(revision 9088)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorCreator.cs	(revision 9089)
@@ -23,5 +23,6 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,5 +34,18 @@
   [Item("CombinedIntegerVectorCreator", "A base class for operators creating combined int-valued vectors.")]
   [StorableClass]
-  public abstract class CombinedIntegerVectorCreator : IntegerVectorCreator, ICombinedIntegerVectorCreator {
+  public abstract class CombinedIntegerVectorCreator : SingleSuccessorOperator, IStochasticOperator, ICombinedIntegerVectorCreator {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<IntValue> LengthParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Length"]; }
+    }
+    public IValueLookupParameter<IntMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<IntMatrix>)Parameters["Bounds"]; }
+    }
+
     public IValueLookupParameter<IntValue> ActionPartLengthParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["ActionPartLength"]; }
@@ -44,14 +58,17 @@
     [StorableConstructor]
     protected CombinedIntegerVectorCreator(bool deserializing) : base(deserializing) { }
-    protected CombinedIntegerVectorCreator(IntegerVectorCreator original, Cloner cloner) : base(original, cloner) { }
+    protected CombinedIntegerVectorCreator(CombinedIntegerVectorCreator original, Cloner cloner) : base(original, cloner) { }
     protected CombinedIntegerVectorCreator()
       : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Length", "The length of the vector."));
+      Parameters.Add(new ValueLookupParameter<IntMatrix>("Bounds", "The bounds matrix can contain one row for each dimension with three columns specifying minimum (inclusive), maximum (exclusive), and step size. If less rows are given the matrix is cycled."));
       Parameters.Add(new LookupParameter<CombinedIntegerVector>("CombinedIntegerVector", "The vector which should be manipulated."));
       Parameters.Add(new ValueLookupParameter<IntValue>("ActionPartLength", "The length of the vector."));
     }
 
-    protected override IntegerVector Create(IRandom random, IntValue length, IntMatrix bounds) {
-      CombinedIntegerVectorParameter.ActualValue = Create(random, length, bounds, ActionPartLengthParameter.ActualValue);
-      return CombinedIntegerVectorParameter.ActualValue;
+    public sealed override IOperation Apply() {
+      CombinedIntegerVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue, BoundsParameter.ActualValue, ActionPartLengthParameter.ActualValue);
+      return base.Apply();
     }
 
